clear
x=(0:0.4:2*pi)';            
y=exp(-0.5*x).*sin(x);        %生成测试数据
x1=(0:0.1:2*pi)';              %插值点 
y0=exp(-0.5*x1).*sin(x1);     %插值点真实值
y1=interp1(x,y,x1,'nearest');     %最接近点插值
disp('interp1函数插值时间');tic
y2=interp1(x,y,x1); toc;       %interp1插值时间
y3=interp1(x,y,x1,'spline') ;      %三次样条插值
disp('interp1q函数插值时间');tic   
yq=interp1q(x,y,x1);toc;          %interp1q插值时间
plot(x1,y1,'--',x1,y2,'-',x1,y3,'-.',x,y,'*',x1,y0,':')
legend('nearest插值数据','linear插值数据','spline插值数据',...
    '样本数据点','插值点真实数据')
max(abs(y0-y3))



